\ ----------------------------------------------------------------------
\ LANGUAGE    : ANS Forth 
\ PROJECT     : CHForth, a Dutch public domain ANS Forth for PC's 
\ DESCRIPTION : 79 STANDARD FORTH 
\ CATEGORY    : Standard programs 
\ AUTHOR      : Coos Haak 
\ LAST CHANGE : May 16, 1994, Coos Haak 
\ ----------------------------------------------------------------------


        ?DEF -79-conv [IF] -79-conv [THEN]

        MARKER -79-conv



vocabulary 79

79 definitions

?undef not-implemented [if]

: not-implemented
        true abort" This word is not yet fully implemented"
        ;

[then]

: do
        r@ rot >r swap >r >r
        ;  compile-only

: i
        r> r@ swap >r
        ;  compile-only

: loop
        r> r> 1+ dup r@ <
        if      r> r@ swap >r swap >r >r drop
        else    drop r> drop r> drop >r
        then
        ;  compile-only

: +loop
        r> swap dup s>d r> s>d d+ rot 0<
        if      2dup r@ s>d d<
                if      2drop r> drop r> drop >r
                else    drop r> r@ swap >r swap >r >r drop
                then
        else    2dup r@ s>d d<
                if      drop r> r@ swap >r swap >r >r drop
                else    2drop r> drop r> drop >r
                then
        then
        ;  compile-only

: leave
        r> r> r> drop dup >r >r >r
        ;  compile-only

: unloop
        not-implemented
        ;  compile-only  immediate

: ?do
        not-implemented
        ;  compile-only  immediate
 
: begin
        r@ >r
        ;  compile-only

: again
        r> drop r@ >r
        ;  compile-only

: until
        if      r> r> drop >r
        else    r> drop r@ >r
        then
        ;  compile-only

: while
        0=
        if      r> drop r> drop
        then
        ;  compile-only

: repeat
        not-implemented
        ;  compile-only  immediate

forth definitions

: lus
        [ 79 ]
        do      i . key? throw
        loop
        ;  forth

: een
        [ 79 ]
        5
        begin   dup . 1- dup 0=
        until
        drop
        ;  forth

: twee
        [ 79 ]
        begin   key? throw
        again
        ;  forth

: sub
        [ 79 ]
        begin   dup . dup 1 >
        while   1-
        again
        ;  forth  compile-only

: go
        5 sub drop
        ;

: 83-speed
        cr timer-reset
        1000 0
        do      1000 0
                do
                loop
        loop
        .elapsed
        ;

: 79-speed
        [ 79 ]
        cr timer-reset
        1000 0
        do      1000 0
                do
                loop
        loop
        .elapsed
        ;  forth

: go79
        [ 79 ]
        1000 0
        do      i . stop?
                if      leave
                then
        3 choose 1- +loop
        ;  forth

: go83
        1000 0
        do      i . stop?
                if      leave
                then
        3 choose 1- +loop
        ;  forth

                            \ (* End of Source *) /
