\ ----------------------------------------------------------------------
\ LANGUAGE    : ANS Forth 
\ PROJECT     : CHForth, a Dutch public domain ANS Forth for PC's 
\ DESCRIPTION : Crystal symmetry, an expert system 
\ CATEGORY    : Examples 
\ AUTHOR      : Coos Haak 
\ LAST CHANGE : May 16, 1994, Coos Haak 
\ ----------------------------------------------------------------------



        NEEDS -expert

        MARKER -symmetry



newsystem

question speciaal       "Is het lichaam een tetraeder, oktaeder of icosaeder ?"
question hoofdas        "Is er een hoofdas ?"
question vlak           "Is er een spiegelvlak ?"
question symmetrie      "Is er een punt van symmetrie ?"
question assen          "Zijn er assen loodrecht op de hoofdas ?"
question hvlak          "Is er een horizontaal vlak ?"
question vvlak          "Zijn er vertikale vlakken ?"

{ speciaal ? }
rule _1 "Doe het zelf, zeg!"

{ hoofdas ? invert & vlak ? }
rule _2 "De puntgroep is Cs"

{ hoofdas ? invert & vlak ? invert & symmetrie ? }
rule _3 "De puntgroep is Ci"

{ hoofdas ? invert & vlak ? invert & symmetrie ? invert }
rule _4 "De puntgroep is C1"

{ assen ? invert & hvlak ? }
rule _5 "De puntgroep is Cnh"

{ assen ? invert & hvlak ? invert & vvlak ? }
rule _6 "De puntgroep is Cnv"

{ assen ? invert & hvlak ? invert & vvlak ? invert }
rule _7 "De puntgroep is Cn"

{ hvlak ? }
rule _8 "De puntgroep is Dnh"

{ vvlak ? }
rule _9 "De puntgroep is Dnd"

{ true }
rule _10 "De puntgroep is Dn"

: go
        cr setup s" Symmetrie van moleculen." c/l over - 2/ htab type
        cr cr
        _1 ! _2 ! _3 ! _4 ! _5 ! _6 ! _7 ! _8 ! _9 ! _10 ! ;

cr .( Turnkey [J,n]) key >upc 'N' <> [if]

turnkey go sym

[then]
                            \ (* End of Source *) /
